-- Author: VertexFloat
-- Date: 29.01.2021
-- Version: Farming Simulator 22, 1.0.0.1
-- Copyright (C): VertexFloat, All Rights Reserved
-- Main function of handling all functions of Manual Combine Discharge

-- Changelog (1.0.0.1) :
--
-- Removed one of the sources

source(g_currentModDirectory .. "src/vehicles/specializations/ManualCombineDischarge.lua")
source(g_currentModDirectory .. "src/gui/hud/ManualCombineDischargeHUD.lua")
source(g_currentModDirectory .. "src/gui/hud/CombineDischargeContext.lua")

local manualCombineDischarge

local function loadMission(mission)
	assert(g_manualCombineDischarge == nil)
	
	manualCombineDischarge = ManualCombineDischargeHUD:new(mission, g_inputDisplayManager, mission.inGameMenu.hud.contextActionDisplay)
	
	getfenv(0).g_manualCombineDischarge = manualCombineDischarge
	
	addModEventListener(manualCombineDischarge)
end

local function delete()
	removeModEventListener(manualCombineDischarge)
	
	manualCombineDischarge:delete()
	manualCombineDischarge = nil
	
	getfenv(0).g_manualCombineDischarge = nil
end

local function init()
	g_specializationManager:addSpecialization('ManualCombineDischarge', 'ManualCombineDischarge', Utils.getFilename('src/vehicles/specializations/ManualCombineDischarge.lua', g_currentModDirectory), true, nil)
	
	for vehicleName, vehicleType in pairs(g_vehicleTypeManager.types) do
		if SpecializationUtil.hasSpecialization(Pipe, vehicleType.specializations) and SpecializationUtil.hasSpecialization(Combine, vehicleType.specializations) then
			g_vehicleTypeManager:addSpecialization(vehicleName, 'ManualCombineDischarge')
		end
	end
	
	Mission00.load = Utils.prependedFunction(Mission00.load, loadMission)
	
	FSBaseMission.delete = Utils.appendedFunction(FSBaseMission.delete, delete)
end

init()